#include "stack.cpp"

class Queue
{
    Stack stack1;
    Stack stack2;
    bool current = true; // true means stack1
    unsigned int count = 0;

    void one_to_two()
    {
        if(current)
        {
            for(int i = 0; i<count; i++) stack2.push(stack1.pop());
            current = false;
        }
        else throw("Current is not true");
    }

    void two_to_one()
    {
        if(!current)
        {
            for(int i = 0; i<count; i++) stack1.push(stack2.pop());
            current = true;
        }
        else throw("Current is not false");
    }

    public:
    void enqueue(int item)
    {
        if(current) stack1.push(item);
        else
        {
            two_to_one();
            current = true;
            enqueue(item);
        }
        count++;
    }

    int dequeue()
    {
        if(!current) return stack2.pop();
        else
        {
            one_to_two();
            current = true;
            dequeue();
        }
        count--;
    }

    void print()
    {
        if(current) stack1.print();
        else stack2.print();
    }
};

int main()
{
    Queue queue;
    queue.enqueue(1);
    queue.enqueue(2);
    queue.enqueue(3);
    queue.enqueue(4);
    queue.enqueue(5);
    queue.enqueue(6);
    queue.print();
    return 0;
} 