# include <iostream>

#define SIZE 5

class Stack
{
    int items[SIZE] = {0};
    unsigned int rear = 0;

    public:
    void push(int item)
    {
        items[rear++%SIZE] = item;
    }

    int pop()
    {
        return items[--rear%SIZE];
    }

    int peek()
    {
        return items[(rear - 1)%SIZE];
    }

    bool is_empty()
    {
        return !rear;
    }

    void print()
    {
        for(int i = 0; i<SIZE; i++) std::cout<<items[i]<<std::endl;
    }
}; 